import java.io.*;
import java.lang.*;
import java.util.Vector;

public class statisticNS{

public static void creaGNUscript(String file, double w, double q, int flow, double tMax, double tMaxR){

String fileScriptName="gnuScript.plt";
try{
FileWriter fileScriptOut=new FileWriter(fileScriptName);
BufferedWriter buffScriptOut=new BufferedWriter(fileScriptOut);
PrintWriter printScriptOut=new PrintWriter(buffScriptOut);

double xticsBP=w;
double xticsR=q;

if (tMax/w>20){
	xticsBP=(tMax/20)*100;	      /*arrotondo*/
	xticsBP =(Math.rint(xticsBP)/100);
}

if (tMaxR/q>20){
	xticsR=(tMax/20)*100;	      /*arrotondo*/
	xticsR =(Math.rint(xticsR)/100);
}

printScriptOut.println("#disegna i vari grafici relativi al PLR, BLR, RitEndToEnd ");
printScriptOut.println("#per eseguire lo script direttamente da gnuplot: load 'nomescript.plt' ");
printScriptOut.println();
printScriptOut.println("# Se i valori delle ascisse risultano confusi puoi migliorarli modificando il comando 'set xtics valori_ascisse' ");
printScriptOut.println();

printScriptOut.println("set xtics "+ xticsR);
printScriptOut.println("set grid");
printScriptOut.print("plot '" + file );
printScriptOut.println("_d.dat' with steps");
printScriptOut.println("set title 'Ritardo End-to-End per flusso "+flow+"'");
printScriptOut.println("set xlabel 'tempo(sec) suddiviso in quantili'");
printScriptOut.println("set ylabel 'ritardo end to end'");
printScriptOut.println("set output 'RitEndtoEnd.eps'");
printScriptOut.println("set terminal postscript color");
printScriptOut.println("replot ");
printScriptOut.println();

printScriptOut.println("set xtics "+ xticsBP);
printScriptOut.println("set grid");
printScriptOut.print("plot '" + file );
printScriptOut.println("_p.dat' with steps");
printScriptOut.println("set title 'Packet Loss Rate per flusso "+flow+"'");
printScriptOut.println("set xlabel 'tempo(sec)'");
printScriptOut.println("set ylabel 'pacchetti persi'");
printScriptOut.println("set output 'PackLossRate.eps'");
printScriptOut.println("set terminal postscript color");
printScriptOut.println("replot ");
printScriptOut.println();

printScriptOut.println("set xtics "+ xticsBP);
printScriptOut.println("set grid");
printScriptOut.print("plot '" + file );
printScriptOut.println("_b.dat' with steps");
printScriptOut.println("set title 'Byte Loss Rate per flusso "+flow+"'");
printScriptOut.println("set xlabel 'tempo(sec)'");
printScriptOut.println("set ylabel 'numero byte persi'");
printScriptOut.println("set output 'ByteLossRate.eps'");
printScriptOut.println("set terminal postscript color");
printScriptOut.println("replot ");

buffScriptOut.close();

}
catch(IOException e){}
}

public static void main(String [] args) {

String pathCompleteFT="";
String fileValoriOut="";
String fileTrace="";
String valoreWin="";
String valoreFlw="";
String valoreQnt="";
double qnt=0.001;  //inizializzo il valore del quantile e della finestra temporale
double win=0.001;
int flw=0;
boolean plr=true;
boolean blr=false;
statPB s1=new statPB();
statRitE s2=new statRitE();

try{

System.out.println();
System.out.println();

System.out.println("Indicare il nome del file contente la traccia generata da NS-2 (.tr)");
BufferedReader fileTr= new BufferedReader(new InputStreamReader(System.in));
fileTrace = fileTr.readLine();

int ciclo=0; //contatore
boolean ciclobool=false;
while(!ciclobool&&ciclo<3){
	ciclo++;

	if (!fileTrace.equals("")){ //scritto nome
		if (!fileTrace.endsWith(".tr")){
	     	fileTrace+= ".tr";
	}}
	if (fileTrace.equals("")||!(new File(fileTrace)).exists()){
		System.out.println("Attenzione! Il file non esiste o non e' corretto!");
		System.out.println("Inserire il nome corretto del file");
		fileTrace = fileTr.readLine();
		if(ciclo==2){
			fileTr.close();
			System.exit(-1);
		}

	}else{
		ciclobool=true;
	}
}

pathCompleteFT=(args[0]+"/"+fileTrace); //filetrace
System.out.println();
System.out.println("-- CALCOLO Packet Loss Rate (PLR) e Byte Loss Rate (BLR) -- ");
System.out.println();
System.out.println("Dato un FlowID verranno calcolati i valori di PLR e BLR per ogni finestra temporale.");

System.out.println("Inserire il FlowID");
BufferedReader inFlw = new BufferedReader(new InputStreamReader(System.in));
valoreFlw = inFlw.readLine();
try{
flw=Integer.valueOf(valoreFlw).intValue();
}catch(NumberFormatException e) {
	System.out.println("Ultimo tentativo! Inserire correttamente il FlowID");
	valoreFlw = inFlw.readLine();
	try{
	flw=Integer.valueOf(valoreFlw).intValue();
	}catch(NumberFormatException e1) {
		System.out.println("Il valore non e' corretto!");
		System.exit(-1);
	}
}


System.out.println("Indicare la grandezza della finestra temporale in secondi");
BufferedReader inWin= new BufferedReader(new InputStreamReader(System.in));
valoreWin = inWin.readLine();
System.out.println();
try{
win=Double.valueOf(valoreWin).doubleValue();
}catch(NumberFormatException e) {
	System.out.println("Ultimo tentativo! Inserire correttamente la finestra");
	valoreWin = inWin.readLine();
	try{
	win=Double.valueOf(valoreWin).doubleValue();
	}catch(NumberFormatException e1) {
		System.out.println("La finestra non e' corretta!");
		System.exit(-1);
	}
}


System.out.println();
System.out.println("-- CALCOLO Distribuzione del Ritardo end-to-end -- ");
System.out.println("Verra' calcolata la distribuzione del ritardo e-t-e per il FlowID inserito precedentemente.");
System.out.println();
System.out.println("Inserire il valore del quantile");
BufferedReader inQnt = new BufferedReader(new InputStreamReader(System.in));
valoreQnt = inQnt.readLine();
try{
qnt=Double.valueOf(valoreQnt).doubleValue();
}catch(NumberFormatException e) {
	System.out.println("Ultimo tentativo! Inserire correttamente il quantile");
	valoreQnt = inQnt.readLine();
	try{
	qnt=Double.valueOf(valoreQnt).doubleValue();
	}catch(NumberFormatException e1) {
		System.out.println("Il quantile non e' corretto!");
		System.exit(-1);
	}
}


System.out.println();

System.out.println("Inserire il nome del file che conterra' i valori calcolati");
BufferedReader inPlr = new BufferedReader(new InputStreamReader(System.in));
fileValoriOut = inPlr.readLine();

if (fileValoriOut.equals("")){
	System.out.println("ATTENZIONE! Stringa vuota! Inserire il nome del file");
	fileValoriOut = inPlr.readLine();
	if (fileValoriOut.equals("")){
		System.out.println("Stringa vuota!");
		System.exit(-1);
	}

}

System.out.println();

fileTr.close();
inQnt.close();
inWin.close();
inPlr.close();

}
catch(IOException e){}

double tempoMax=s1.calcoloPB(Double.valueOf(valoreWin).doubleValue(),Integer.valueOf(valoreFlw).intValue(), pathCompleteFT);
s1.creaFile(fileValoriOut,plr);
s1.creaFile(fileValoriOut,blr);

double tempoMaxR=s2.calcoloRit(Double.valueOf(valoreQnt).doubleValue(),Integer.valueOf(valoreFlw).intValue(),fileValoriOut, pathCompleteFT);/*valore quantile, valore flusso, nome del file delay*/

creaGNUscript(fileValoriOut,win,qnt,flw,tempoMax,tempoMaxR);
}


}


