set ns [new Simulator]
$ns set cosim_type 0

#### Open files for statistics #####
set traceFile [open congestione.tr w]
$ns trace-all $traceFile
set namFile [open congestione.nam w]
$ns namtrace-all $namFile

proc finish {} {
	global ns
	global namFile
	global traceFile
	$ns flush-trace
	close $namFile
	close $traceFile
	exit 0
}

set node0 [$ns node]
set node1 [$ns node]
set node2 [$ns node]
set node3 [$ns node]
set node4 [$ns node]
set node5 [$ns node]

$ns duplex-link $node0 $node2 10Mb 10ms DropTail
$ns duplex-link $node1 $node2 10Mb 10ms DropTail
$ns duplex-link $node4 $node3 10Mb 10ms DropTail
$ns duplex-link $node5 $node3 10Mb 10ms DropTail

# bottleneck link
$ns duplex-link $node2 $node3 100kb 20ms DropTail
$ns duplex-link-op $node2 $node3 queuePos 0.5
$ns queue-limit $node2 $node3 15

# monitor the bottleneck every 0.1 sec and store in .out
$ns monitor-queue $node2 $node3 [open congestione.queue w] 0.1
[$ns link $node2 $node3] queue-sample-timeout;

# on Ethernet the max IP packet size is 1500 byte
set udp0 [new Agent/UDP]
$udp0 set packetSize_ 1500
$udp0 set fid_ 1000
set null0 [new Agent/Null]

$ns attach-agent $node0 $udp0
$ns attach-agent $node4 $null0
$ns connect $udp0 $null0

set cbr0 [new Application/Traffic/CBR]
$cbr0 set packetSize_ 400
$cbr0 set interval_ 0.040
$cbr0 attach-agent $udp0

# setup a TCP connection
set tcp [new Agent/TCP]
$tcp set fid_ 2000
set sink [new Agent/TCPSink]
$ns attach-agent $node1 $tcp
$ns attach-agent $node5 $sink
$ns connect $tcp $sink
set ftp [new Application/FTP]
$ftp attach-agent $tcp

$ns at 1.0 "$cbr0 start"
$ns at 5.0 "$ftp start" 
$ns at 21.0 "$cbr0 stop"
$ns at 25.0 "$ftp stop" 
$ns at 30.0 "finish"
$ns run

