#!/usr/bin/perl
# type: perl dpck-flow-F-at-link.pl <tracefile> <flow> <node0> <node1> <granularity>

$infile=$ARGV[0];
$flowid=$ARGV[1];
$fromnode=$ARGV[2];
$tonode=$ARGV[3];
$granularity=$ARGV[4];

# compute how many packets belonging to a given flow are dropped at a 
# given link (from node0 to node1)
# during the time interval specified by granularity parameter in seconds

$sum=0;
$clock=0;

open (DATA, "<$infile") 
   || die "Can't open $infile $!";

print STDOUT "Time \t Dropped packets\n";

while (<DATA>) 
{ 
  @x = split(' ');
  if($x[1]-$clock <= $granularity)
  {
    if($x[0] eq 'd')
    {
      if($x[2] eq $fromnode)
      {
        if($x[3] eq $tonode)
        {
	  if($x[7] eq $flowid)
	  {
            $sum=$sum+1;
          }
	}
      }
    }
  }
  else
  {
    print STDOUT "$x[1] \t $sum\n";
    $clock=$clock+$granularity;
    $sum=0;
  }
}
print STDOUT "$x[1] \t $sum\n";
$clock=$clock+$granularity;
$sum=0;

close DATA;
exit(0);

