#!/usr/bin/perl
# type: perl jitter-flow-F-at-node.pl <tracefile> <flowID> <node> <period> <granularity>

$infile=$ARGV[0];
$flowid=$ARGV[1];
$tonode=$ARGV[2];
$period=$ARGV[3];
$granularity=$ARGV[4];

# we print the jitter of packets sequence belonging to the same flow 
# arriving at a given node during time interval specified by 
# granularity parameter in seconds
# we use the method reported in RFC 3550 assuming periodic transmission
# D(i,j) = |(Ri - Rj)-(Si - Sj)| = |(Ri - Rj)-P|

$npck = 0;
$sum = 0;
$Rj = 0;
$clock=0;

open (DATA, "<$infile") 
   || die "Can't open $infile $!";

print STDOUT "Tempo \t Jitter\n";

while (<DATA>) 
{ 
  @x = split(' ');
  if($x[1]-$clock <= $granularity)
  {
    if($x[7] eq $flowid)
    {
      if($x[0] eq 'r')
      {
        if($x[3] eq $tonode)
        {
	  if($Rj eq 0)
	  {
	    $Rj = $x[1];
	  }
	  else
	  {
            $npck = $npck + 1;
	    $sum = $sum + abs($x[1]-$Rj-$period);
	    $Rj = $x[1];
	  }
        }
      }
    }
  }
  else
  {
    if($npck eq 0)
    {
      print STDOUT "$x[1] \t no packets\n";
    }
    else
    {
      $jitter=$sum/$npck;
      print STDOUT "$x[1] \t $jitter sec.\n";
    }
    $clock=$clock+$granularity;
    $npck = 0;
    $sum = 0;
    $Rj = 0;
  }
}

if($npck eq 0)
{
  print STDOUT "$x[1] \t no packets\n";
}
else
{
  $jitter=$sum/$npck;
  print STDOUT "$x[1] \t $jitter sec.\n";
}

close DATA;
exit(0);

